#ifndef _UNISTD_H_
#define _UNISTD_H_

#include <sys/types.h>
//#include <syscalls.h>

#ifndef SEEK_SET
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#endif

#define STDIN_FILENO	0
#define STDOUT_FILENO	1
#define STDERR_FILENO	2

extern int mkdir(char *, mode_t);
extern int rmdir(char *);

extern long tell(int);
extern off_t lseek(int, off_t, int);

extern int isatty(int);

extern int lstat(char *, void *);
extern int readlink(char *, char *, int);

extern char **environ;

extern char *_findPath(char *pathname);
extern int execl(char *pathname, char *arg0, ...);
extern int execle(char *pathname, char *arg0, ...);
extern int execlp(char *pathname, char *arg0, ...);
extern int execlpe(char *pathname, char *arg0, ...);
extern int execv(char *pathname, char *argv[]);
extern int exect(char *pathname, char *argv[], char *envp[]);
extern int execvp(char *pathname, char *argv[]);
extern int execvpe(char *pathname, char *argv[], char *envp[]);

extern char *ttyname(int);
extern int system(char *);
extern int pause(void);
extern int fork(void);
extern char *getcwd(char *, int);

extern void exit(int);

#ifndef R_OK
#define R_OK	4	/* Test for read permission.  */
#define W_OK	2	/* Test for write permission.  */
#define X_OK	1	/* Test for execute permission.  */
#define F_OK	0	/* Test for existence.	*/
#endif

#endif /* _UNISTD_H_ */
