/*
 * drawcell.asm, draw a 4x6 cell character
 * Copyright 2004 Chris Williams
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

.include "sys/lcd.inc"

.text
.global drawcell
| 6x4 (small) font
| drawcell(int row, int col, int c)
drawcell:
	movem	%d3/%d4,-(%sp)
	move	4+4(%a7),%d1	| row
	move	4+6(%a7),%d2	| col
	move	4+8(%a7),%d0	| c
	
	| get address on screen
	mulu	#6*LCD_INCY,%d1
	
	clr	%d3		| amount to shift
	moveq	#0x0F,%d4	| AND mask
	asr	#1,%d2		| col / 2
	bcc.s	0f		| is col even?
	moveq	#4,%d3		| uneven (by one nibble)
	move.b	#0xF0,%d4
0:
	add	%d2,%d1		| + col
	move	%d1,%a0
	lea	GLOBAL_LCD_MEM(%a0),%a0	| address on screen
	| %a0 holds screen address
	| %d3 holds shift amount
	| %d4.b holds mask
	
	| get address of glyph
	and	#0xFF,%d0		| limit the char # to [0,255]
	mulu	#6,%d0
	move	%d0,%a1
	lea	smallfont(%a1,%pc),%a1
	|add.l	#smallfont,%a1	| address of font data
	| %a1 holds glyph address
	
	moveq	#LCD_INCY,%d0
	moveq	#6-1,%d2		| num rows in glyph - 1
0:
	move.b	(%a1)+,%d1	| get a row of glyph
	lsr.b	%d3,%d1		| shift glyph
	
	and.b	%d4,(%a0)		| mask byte on screen
	or.b	%d1,(%a0)		| and put glyph row there
	
	add	%d0,%a0		| next screen row
	dbra	%d2,0b
	
	movem	(%sp)+,%d3/%d4
	rts
