/*
 * Punix - *nix-like kernel for TI-92+/V200
 * Copyright (C) 2003 PpHd
 * Copyright 2004 Chris Williams
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

| include "const.h"

.global Int_1
.global Int_2
.global Int_3
.global Int_4
.global Int_5
.global Int_6
.global Int_7

.text
| Scan for the hardware to know what keys are pressed 
Int_1:
	rte

| Does nothing. Why ? Look:
|  Triggered when the *first* unmasked key (see 0x600019) is *pressed*.
|  Keeping the key pressed, or pressing another without released the first
|  key, will not generate additional interrupts.  The keyboard is not
|  debounced in hardware and the interrupt can occasionally be triggered many
|  times when the key is pressed and sometimes even when the key is released!
|  So, you understand why you don't use it ;)
|  Write any value to 0x60001B to acknowledge this interrupt.
Int_2:	move.w	#0x2600,%sr
	move.w	#0x00FF,0x60001A	| acknowledge Int2
Int_3:	rte				| Clock for int 3 ?

| Link Auto-Int
Int_4:
	rte	

| Auto-Ints which allows the system timers.
Int_5:
	rte

| ON Int.
|	2ND / DIAMOND : Off
|	ESC : Reset
Int_6:
	rte

Int_7:
	jmp	start

.global BUS_ERROR
.global SPURIOUS
.global ADDRESS_ERROR
.global ILLEGAL_INSTR
.global ZERO_DIVIDE
.global CHK_INSTR
.global I_TRAPV
.global PRIVILEGE
.global TRACE
.global LINE_1010
.global LINE_1111

.text
.even
BUS_ERROR:
SPURIOUS:
ADDRESS_ERROR:
ILLEGAL_INSTR:
ZERO_DIVIDE:
CHK_INSTR:
I_TRAPV:
PRIVILEGE:
TRACE:
LINE_1010:	| I don't know (send signal SIGILL?)
LINE_1111:	| This should be a floating-point emulator
	rte
