/*
 * Here's an untested implementation of the switchthread function.
 * Saves all registers on stack, saves old stack pointer, switches stacks
 * (restores new stack pointer), and restores all registers from stack.
 * 
 * A "thread" here is defined as a path of execution and associated stack. The
 * execution state (return address and registers) is stored on the stack, so
 * all that's needed to know about the thread is the stack pointer, and that is
 * stored at the location given in the first argument.
 * 
 * It is safe for **oldspp to be NULL, and it's also safe for **newspp to be
 * NULL iff newspp == oldspp.
 * 
 * Should this use register arguments?
 * switchthread(int **oldspp asm("a0"), int **newspp asm("a1")) could work
 */

	.global switchthread
	.even
	.section _st1, "x"
| switchthread(int **oldspp, int **newspp);
switchthread:
	movem.l	%a0-%a1,-(%sp)
	move.l	4+4+4(%sp),%a0	| oldspp
	move.l	4+4+8(%sp),%a1	| newspp
	cmp.l	%a0,%a1
	beq.s	0f		| don't switch if not needed
	movem.l	%d0-%d7/%a2-%a6,-(%sp)
	move.l	%usp,%a2
	move.l	%a2,-(%sp)	| save user stack
	
	| save old sp
	move.l	%sp,(%a0)
	
	| restore new sp
	move.l	(%a1),%sp
	
	move.l	(%sp)+,%a0
	move.l	%a0,%usp	| restore user stack
	movem.l	(%sp)+,%d0-%d7/%a2-%a6
0:	movem.l	(%sp)+,%a0-%a1
	rts
