#include <sys/sysent.h>
#include <sys/punix.h>

void sys_NONE();
void sys_exit();
void sys_fork();
void sys_vfork();
void sys_read();
void sys_write();
void sys_open();
void sys_close();
void sys_dup();
void sys_dup2();
void sys_lseek();
void sys_execv();
void sys_execve();
void sys_getdtablesize();

STARTUP(struct sysent sysent[]) = {
	{0, sys_NONE},		/* 0 */
	{1, sys_exit},
	{0, sys_fork},
	{4, sys_read},
	{4, sys_write},
	{4, sys_open},
	{1, sys_close},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},		/* 10 */
	{4, sys_execv},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{4, sys_lseek},
	{0, sys_NONE},		/* 20 */
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},		/* 30 */
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},		/* 40 */
	{1, sys_dup},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},		/* 50 */
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{6, sys_execve},
	{0, sys_NONE},		/* 60 */
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_vfork},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},		/* 70 */
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},		/* 80 */
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_NONE},
	{0, sys_getdtablesize},
	{2, sys_dup2},		/* 90 */
};

const int nsysent = sizeof(sysent) / sizeof(struct sysent);

STARTUP(char *sysname[]) = {
	"NONE",		/* 0 */
	"exit",
	"fork",
	"read",
	"write",
	"open",
	"close",
	"NONE",
	"NONE",
	"NONE",
	"NONE",		/* 10 */
	"execv",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"lseek",
	"NONE",		/* 20 */
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",		/* 30 */
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",		/* 40 */
	"dup",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",		/* 50 */
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"execve",
	"NONE",		/* 60 */
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",		/* 70 */
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",		/* 80 */
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"NONE",
	"getdtablesize",
	"dup2",		/* 90 */
};
