#include <sys/proc.h>
#include <sys/punix.h>
#include <errno.h>

void panic(const char *s);

STARTUP(void sys_fork())
{
	GLOBAL_current->p_error = ENOMEM;	/* we lie (snicker) */
}

/* allocate a process structure */
STARTUP(struct proc *palloc())
{
	struct proc *p;
	if ((p = GLOBAL_freeproc) == NULL)
		return (struct proc *)NULL;
	
	GLOBAL_freeproc = p->p_next;
	return p;
}

/* find an unused process id */
int pidget()
{
	return -1;
}

/*
 * newproc()
 * in-kernel fork function
 * returns 0 for old proc, 1 for new proc
 *
 */
int newproc()
{
	struct proc *p, *cp;
	int pid;
	
	pid = pidget();
	if ((p = palloc()) == NULL)
		panic("no procs");
	
	cp = GLOBAL_current;
	
	/* are these all I need? */
	p->p_uid = cp->p_uid;
	p->p_pgrp = cp->p_pgrp;
	p->p_nice = cp->p_nice;
	p->p_pid = pid;
	p->p_ppid = cp->p_pid;
	p->p_pptr = cp;
	p->p_time = 0;
	p->p_cpu = 0;
	p->p_sigmask = cp->p_sigmask;
	p->p_sigcatch = cp->p_sigcatch;
	p->p_sigignore = cp->p_sigignore;
	
	p->p_next = GLOBAL_allproc;
	GLOBAL_allproc = p;
	
	/* increment reference counts on all shared objects */
	
	/* */
	/* FIXME: finish writing this */
	return 0;
}

/* free a process structure */
void pfree(struct proc *p)
{
	if (p) {
		p->p_next = GLOBAL_freeproc;
		GLOBAL_freeproc = p;
	}
}
