.ifndef _PROC_INC_
_PROC_INC_ = 1

/*
#include "type.h"
#include <time.h>
#include <signal.h>
#include <sys/types.h>
*/

.include "procglo.inc"

NR_PROCS	= 10

| struct proc {
proc.p_reg	= 0				| struct stackframe_s p_reg;

.if 0
	reg_t p_splow;		/* lowest observed stack value */
	int p_trap;		/* trap type (only low byte) */
#if (SHADOWING == 0)
	char *p_crp;		/* mmu table pointer (really struct _rpr *) */
#else
	phys_clicks p_shadow;	/* set if shadowed process image */
	int align;		/* make the struct size a multiple of 4 */
#endif
	char p_physio;		/* cannot be (un)shadowed now if set */
#if defined(FPP)
	struct fsave p_fsave;	/* FPP state frame and registers */
	int align2;		/* make the struct size a multiple of 4 */
#endif
.endif

proc.p_stguard	= proc.p_reg+72	| reg_t *p_stguard;

proc.p_nr	= proc.p_stguard+4		| int p_nr;

proc.p_int_blocked	= proc.p_nr+2		| int p_int_blocked;
proc.p_int_held	= proc.p_int_blocked+2	| int p_int_held;
proc.p_nextheld	= proc.p_int_held+2	| struct proc *p_nextheld;

proc.p_flags	= proc.p_nextheld+4		| int p_flags;
proc.p_pid	= proc.p_flags+2		| pid_t p_pid;

proc.p_arg	= proc.p_pid+2		| int p_arg[8];

proc.p_retval	= proc.p_arg+16		| unsigned long p_retval;
proc.p_long	= proc.p_retval		| long p_long;
proc.p_off	= proc.p_retval		| off_t p_off;
proc.p_time	= proc.p_retval		| time_t p_time;

proc.p_error	= proc.p_retval+4

proc.user_time	= proc.p_error+2	| clock_t user_time;
proc.sys_time	= proc.user_time+4		| clock_t sys_time;
proc.child_utime	= proc.sys_time+4	| clock_t child_utime;
proc.child_stime	= proc.child_utime+4	| clock_t child_stime;
proc.p_alarm	= proc.child_stime+4		| clock_t p_alarm;

proc.p_sendlink	= proc.p_alarm+4	| struct proc *p_sendlink;
proc.p_sendto	= proc.p_sendlink+4		| int p_sendto;

proc.p_nextready	= proc.p_sendto+2	| struct proc *p_nextready;
proc.p_pending	= proc.p_nextready+4	| sigset_t p_pending;
proc.p_pendcount	= proc.p_pending+2	| unsigned p_pendcount;

proc.p_name	= proc.p_pendcount+2		| char p_name[16];
proc.sizeof	= proc.p_name+16		| sizeof proc
|};

/* Bits for p_flags in proc[].  A process is runnable iff p_flags == 0. */
.define P_SLOT_FREE	 001	/* set when slot is not in use */
.define NO_MAP  	 002	/* keeps unmapped forked child from running */
.define SENDING 	 004	/* set when process blocked trying to send */
.define RECEIVING	 010	/* set when process blocked trying to recv */
.define PENDING 	 020	/* set when inform() of signal pending */
.define SIG_PENDING	 040	/* keeps to-be-signalled proc from running */
.define P_STOP  	0100	/* set when process is being traced */

.endif /* _PROC_INC_ */
